import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { Express, ExpressParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询物流公司
 */
export async function pageExpress(params: ExpressParam) {
  const res = await request.get<ApiResult<PageResult<Express>>>(
    MODULES_API_URL + '/shop/express/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询物流公司列表
 */
export async function listExpress(params?: ExpressParam) {
  const res = await request.get<ApiResult<Express[]>>(
    MODULES_API_URL + '/shop/express',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加物流公司
 */
export async function addExpress(data: Express) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改物流公司
 */
export async function updateExpress(data: Express) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除物流公司
 */
export async function removeExpress(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除物流公司
 */
export async function removeBatchExpress(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询物流公司
 */
export async function getExpress(id: number) {
  const res = await request.get<ApiResult<Express>>(
    MODULES_API_URL + '/shop/express/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
